{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.LinearSolver
       (
         LinearSolver,
         LinearSolverClass(..),
         linearSolver__0,
         linearSolver__1,
         linearSolver__2,
         linearSolver__3,
         linearSolver_doc,
         linearSolver_getFactorizationSparsity__0,
         linearSolver_getFactorizationSparsity__1,
         linearSolver_getFactorization__0,
         linearSolver_getFactorization__1,
         linearSolver_hasPlugin,
         linearSolver_loadPlugin,
         linearSolver_prepare,
         linearSolver_prepared,
         linearSolver_solve__0,
         linearSolver_solve__1,
         linearSolver_solve__2,
         linearSolver_solve__3,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.CToolsInstances ( )
import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__CONSTRUCTOR__0" c_casadi__LinearSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr Sparsity' -> IO (Ptr LinearSolver')
casadi__LinearSolver__CONSTRUCTOR__0
  :: String -> Sparsity -> IO LinearSolver
casadi__LinearSolver__CONSTRUCTOR__0 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__CONSTRUCTOR__0 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver__0 :: String -> Sparsity -> IO LinearSolver
linearSolver__0 = casadi__LinearSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__CONSTRUCTOR__1" c_casadi__LinearSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr Sparsity' -> CInt -> IO (Ptr LinearSolver')
casadi__LinearSolver__CONSTRUCTOR__1
  :: String -> Sparsity -> Int -> IO LinearSolver
casadi__LinearSolver__CONSTRUCTOR__1 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__CONSTRUCTOR__1 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver__1 :: String -> Sparsity -> Int -> IO LinearSolver
linearSolver__1 = casadi__LinearSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__CONSTRUCTOR__2" c_casadi__LinearSolver__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> Ptr Sparsity' -> IO (Ptr LinearSolver')
casadi__LinearSolver__CONSTRUCTOR__2
  :: Sparsity -> IO LinearSolver
casadi__LinearSolver__CONSTRUCTOR__2 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__CONSTRUCTOR__2 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver__2 :: Sparsity -> IO LinearSolver
linearSolver__2 = casadi__LinearSolver__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__CONSTRUCTOR__3" c_casadi__LinearSolver__CONSTRUCTOR__3
  :: Ptr (Ptr StdString) -> Ptr Sparsity' -> CInt -> IO (Ptr LinearSolver')
casadi__LinearSolver__CONSTRUCTOR__3
  :: Sparsity -> Int -> IO LinearSolver
casadi__LinearSolver__CONSTRUCTOR__3 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__CONSTRUCTOR__3 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver__3 :: Sparsity -> Int -> IO LinearSolver
linearSolver__3 = casadi__LinearSolver__CONSTRUCTOR__3


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__doc" c_casadi__LinearSolver__doc
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr StdString)
casadi__LinearSolver__doc
  :: String -> IO String
casadi__LinearSolver__doc x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__doc errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_doc :: String -> IO String
linearSolver_doc = casadi__LinearSolver__doc


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__getFactorization__0" c_casadi__LinearSolver__getFactorization__0
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> IO (Ptr DMatrix')
casadi__LinearSolver__getFactorization__0
  :: LinearSolver -> IO DMatrix
casadi__LinearSolver__getFactorization__0 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__getFactorization__0 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_getFactorization__0 :: LinearSolverClass a => a -> IO DMatrix
linearSolver_getFactorization__0 x = casadi__LinearSolver__getFactorization__0 (castLinearSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__getFactorization__1" c_casadi__LinearSolver__getFactorization__1
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> CInt -> IO (Ptr DMatrix')
casadi__LinearSolver__getFactorization__1
  :: LinearSolver -> Bool -> IO DMatrix
casadi__LinearSolver__getFactorization__1 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__getFactorization__1 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_getFactorization__1 :: LinearSolverClass a => a -> Bool -> IO DMatrix
linearSolver_getFactorization__1 x = casadi__LinearSolver__getFactorization__1 (castLinearSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__getFactorizationSparsity__0" c_casadi__LinearSolver__getFactorizationSparsity__0
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> IO (Ptr Sparsity')
casadi__LinearSolver__getFactorizationSparsity__0
  :: LinearSolver -> IO Sparsity
casadi__LinearSolver__getFactorizationSparsity__0 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__getFactorizationSparsity__0 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_getFactorizationSparsity__0 :: LinearSolverClass a => a -> IO Sparsity
linearSolver_getFactorizationSparsity__0 x = casadi__LinearSolver__getFactorizationSparsity__0 (castLinearSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__getFactorizationSparsity__1" c_casadi__LinearSolver__getFactorizationSparsity__1
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> CInt -> IO (Ptr Sparsity')
casadi__LinearSolver__getFactorizationSparsity__1
  :: LinearSolver -> Bool -> IO Sparsity
casadi__LinearSolver__getFactorizationSparsity__1 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__getFactorizationSparsity__1 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_getFactorizationSparsity__1 :: LinearSolverClass a => a -> Bool -> IO Sparsity
linearSolver_getFactorizationSparsity__1 x = casadi__LinearSolver__getFactorizationSparsity__1 (castLinearSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__hasPlugin" c_casadi__LinearSolver__hasPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO CInt
casadi__LinearSolver__hasPlugin
  :: String -> IO Bool
casadi__LinearSolver__hasPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__hasPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_hasPlugin :: String -> IO Bool
linearSolver_hasPlugin = casadi__LinearSolver__hasPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__loadPlugin" c_casadi__LinearSolver__loadPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO ()
casadi__LinearSolver__loadPlugin
  :: String -> IO ()
casadi__LinearSolver__loadPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__loadPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_loadPlugin :: String -> IO ()
linearSolver_loadPlugin = casadi__LinearSolver__loadPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__prepare" c_casadi__LinearSolver__prepare
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> IO ()
casadi__LinearSolver__prepare
  :: LinearSolver -> IO ()
casadi__LinearSolver__prepare x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__prepare errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_prepare :: LinearSolverClass a => a -> IO ()
linearSolver_prepare x = casadi__LinearSolver__prepare (castLinearSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__prepared" c_casadi__LinearSolver__prepared
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> IO CInt
casadi__LinearSolver__prepared
  :: LinearSolver -> IO Bool
casadi__LinearSolver__prepared x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__prepared errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_prepared :: LinearSolverClass a => a -> IO Bool
linearSolver_prepared x = casadi__LinearSolver__prepared (castLinearSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__solve__0" c_casadi__LinearSolver__solve__0
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> Ptr MX' -> Ptr MX' -> IO (Ptr MX')
casadi__LinearSolver__solve__0
  :: LinearSolver -> MX -> MX -> IO MX
casadi__LinearSolver__solve__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__solve__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_solve__0 :: LinearSolverClass a => a -> MX -> MX -> IO MX
linearSolver_solve__0 x = casadi__LinearSolver__solve__0 (castLinearSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__solve__1" c_casadi__LinearSolver__solve__1
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> Ptr MX' -> Ptr MX' -> CInt -> IO (Ptr MX')
casadi__LinearSolver__solve__1
  :: LinearSolver -> MX -> MX -> Bool -> IO MX
casadi__LinearSolver__solve__1 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__solve__1 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_solve__1 :: LinearSolverClass a => a -> MX -> MX -> Bool -> IO MX
linearSolver_solve__1 x = casadi__LinearSolver__solve__1 (castLinearSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__solve__2" c_casadi__LinearSolver__solve__2
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> IO ()
casadi__LinearSolver__solve__2
  :: LinearSolver -> IO ()
casadi__LinearSolver__solve__2 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__solve__2 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_solve__2 :: LinearSolverClass a => a -> IO ()
linearSolver_solve__2 x = casadi__LinearSolver__solve__2 (castLinearSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LinearSolver__solve__3" c_casadi__LinearSolver__solve__3
  :: Ptr (Ptr StdString) -> Ptr LinearSolver' -> CInt -> IO ()
casadi__LinearSolver__solve__3
  :: LinearSolver -> Bool -> IO ()
casadi__LinearSolver__solve__3 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LinearSolver__solve__3 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
linearSolver_solve__3 :: LinearSolverClass a => a -> Bool -> IO ()
linearSolver_solve__3 x = casadi__LinearSolver__solve__3 (castLinearSolver x)

